diff -a -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -N -r -u ./src/networks/fasttrack/fasttrackServers.ml ./src/networks/fasttrack/fasttrackServers.ml
--- ./src/networks/fasttrack/fasttrackServers.ml	2006-05-20 01:43:54.000000000 +0200
+++ ./src/networks/fasttrack/fasttrackServers.ml	2006-09-19 19:03:10.000000000 +0200
@@ -322,7 +322,7 @@
       )  file.file_searches
   ) !connected_servers
 
-let really_download_file (r : CommonTypes.result_info) =
+let really_download_file (r : CommonTypes.result_info) user =
   let rec iter uids =
     match uids with
       uid :: tail ->
@@ -334,7 +334,7 @@
   let hash,file_temp = iter r.result_uids in
 
   let file = new_file file_temp (List.hd r.result_names)
-    r.result_size [Uid.create (Md5Ext hash)] in
+    r.result_size [Uid.create (Md5Ext hash)] user in
   if !verbose then
     lprintf "DOWNLOAD FILE %s\n" file.file_name;
   if not (List.memq file !current_files) then begin
diff -a -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -N -r -u ./src/networks/fileTP/fileTPClients.ml ./src/networks/fileTP/fileTPClients.ml
--- ./src/networks/fileTP/fileTPClients.ml	2006-08-09 01:55:28.000000000 +0200
+++ ./src/networks/fileTP/fileTPClients.ml	2006-09-19 19:03:10.000000000 +0200
@@ -63,9 +63,9 @@
   if (filesize = 0L || !!chunk_size = 0) then 1
   else Int64.to_int ((filesize) // (min_range_size file)) + 5
 
-let pause_for_cause f r = 
+let pause_for_cause f r user =
   lprintf_nl "Pausing file %s (%s)" (file_best_name f) r;
-  file_pause (as_file f)
+  file_pause (as_file f) user
 
 let disconnect_client c r =
   match c.client_sock with
diff -a -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -N -r -u ./src/networks/fileTP/fileTPComplexOptions.ml ./src/networks/fileTP/fileTPComplexOptions.ml
--- ./src/networks/fileTP/fileTPComplexOptions.ml	2006-05-25 21:47:25.000000000 +0200
+++ ./src/networks/fileTP/fileTPComplexOptions.ml	2006-09-19 19:03:10.000000000 +0200
@@ -78,8 +78,7 @@
       Md4.of_string (get_value "file_id" value_to_string)
     with _ -> failwith "Bad file_id"
   in
-
-  let file = new_file file_id file_name file_size in
+  let file = new_file file_id file_name file_size CommonUserDb.admin_user in
 
   (match file.file_swarmer with
       None -> ()
diff -a -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -N -r -u ./src/networks/fileTP/fileTPFTP.ml ./src/networks/fileTP/fileTPFTP.ml
--- ./src/networks/fileTP/fileTPFTP.ml	2006-05-30 12:54:14.000000000 +0200
+++ ./src/networks/fileTP/fileTPFTP.ml	2006-09-19 19:03:10.000000000 +0200
@@ -278,13 +278,13 @@
                 | "530 " ->
                     let reason = String.sub line 4 (slen - 4) in
                     if not (retry_530 reason) then begin
-                      pause_for_cause d.download_file "530";
+                      pause_for_cause d.download_file "530" CommonUserDb.admin_user;
                     end else begin
                       c.client_reconnect <- true;
                     end;
                     disconnect_client c Closed_by_user;
                 | "550 " ->
-                    pause_for_cause d.download_file "550";
+                    pause_for_cause d.download_file "550" CommonUserDb.admin_user;
                     disconnect_client c Closed_by_user;
                 | _ -> 
                     if !verbose then lprintf_nl "Unexpected line %s" line;
@@ -443,11 +443,11 @@
                     | "530 " ->
                       let reason = String.sub line 4 (slen - 4) in
                       if not (retry_530 reason) then begin
-                        pause_for_cause file "530";
+                        pause_for_cause file "530" CommonUserDb.admin_user;
                       end;
                       close sock Closed_by_user;
                     | "550 " ->
-                      pause_for_cause file "550";
+                      pause_for_cause file "550" CommonUserDb.admin_user;
                       close sock Closed_by_user;
                     | _ -> 
                       if !verbose then lprintf_nl "Unexpected line %s" line;
diff -a -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -N -r -u ./src/networks/fileTP/fileTPGlobals.ml ./src/networks/fileTP/fileTPGlobals.ml
--- ./src/networks/fileTP/fileTPGlobals.ml	2006-09-01 18:22:15.000000000 +0200
+++ ./src/networks/fileTP/fileTPGlobals.ml	2006-09-19 19:03:10.000000000 +0200
@@ -138,7 +138,7 @@
       file_must_update (as_file file);
     end
 
-let new_file file_id file_name file_size =
+let new_file file_id file_name file_size user =
   let file_temp = Filename.concat !!temp_directory
       (Printf.sprintf "FileTP-%s" (Md4.to_string file_id)) in
   let t = Unix32.create_rw file_temp in
@@ -152,6 +152,8 @@
       file_nconnected_clients = 0;
     } and file_impl =  {
       dummy_file_impl with
+      impl_file_owner = user;
+      impl_file_group = CommonUserDb.user2_user_default_group user;
       impl_file_fd = Some t;
       impl_file_size = zero;
       impl_file_downloaded = zero;
@@ -168,11 +170,11 @@
 (*      lprintf "ADD FILE TO DOWNLOAD LIST\n"; *)
   file
 
-let new_file file_id file_name file_size =
+let new_file file_id file_name file_size users =
   try
     Hashtbl.find files_by_uid file_id
   with _ ->
-      let file = new_file file_id file_name file_size  in
+      let file = new_file file_id file_name file_size users in
       Hashtbl.add files_by_uid file_id file;
       file
 
diff -a -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -N -r -u ./src/networks/fileTP/fileTPHTTP.ml ./src/networks/fileTP/fileTPHTTP.ml
--- ./src/networks/fileTP/fileTPHTTP.ml	2006-08-10 19:41:20.000000000 +0200
+++ ./src/networks/fileTP/fileTPHTTP.ml	2006-09-19 19:03:10.000000000 +0200
@@ -174,7 +174,7 @@
       end;
 
     if code < 200 || code > 299 then begin
-      pause_for_cause file (Printf.sprintf "%d" code);
+      pause_for_cause file (Printf.sprintf "%d" code) CommonUserDb.admin_user;
       failwith "Bad HTTP code";
     end;
 
@@ -386,7 +386,7 @@
   (fun c ->
     match c with 
      x when x < 200 || x > 299 -> 
-       pause_for_cause file (string_of_int x);
+       pause_for_cause file (string_of_int x) CommonUserDb.admin_user;
     | _ -> ()
   )
 
diff -a -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -N -r -u ./src/networks/fileTP/fileTPInteractive.ml ./src/networks/fileTP/fileTPInteractive.ml
--- ./src/networks/fileTP/fileTPInteractive.ml	2006-09-05 17:32:17.000000000 +0200
+++ ./src/networks/fileTP/fileTPInteractive.ml	2006-09-19 19:03:10.000000000 +0200
@@ -234,7 +234,7 @@
 
 let previous_url = ref ""  
   
-let download_file url referer = 
+let download_file url referer user =
   let u = Url.of_string url in
 
   if List.mem u !!old_files && !previous_url <> url then begin
@@ -242,7 +242,7 @@
       failwith "URL already downloaded: repeat command again to force";
     end;
 
-  let file = new_file (Md4.random ()) u.Url.full_file zero in
+  let file = new_file (Md4.random ()) u.Url.full_file zero user in
   
   if !verbose then
     lprintf_nl "Started new download: %s from %s" (file_best_name file) url; 
@@ -276,7 +276,7 @@
    It returns true if this file can be handled by fileTP,
    and false otherwise.
  *)
-let op_network_parse_url url =
+let op_network_parse_url url user =
   let location_regexp = "Location: \\(.*\\)" in
   let real_url = get_regexp_string url (Str.regexp location_regexp) in
   if (is_http_torrent url real_url) && !!enable_bittorrent then
@@ -286,7 +286,7 @@
       let length_regexp = "Content-Length: \\(.*\\)" in
        try let length = get_regexp_int url (Str.regexp length_regexp) in
          if (length > 0) then begin
-           download_file real_url ""; "started FileTP download", true
+           download_file real_url "" user; "started FileTP download", true
          end
          else "can not parse Content-Length", false
        with Not_found -> 
@@ -295,7 +295,7 @@
     else 
       if (String2.check_prefix real_url "ftp://") ||
          (String2.check_prefix real_url "ssh://") then (
-      download_file real_url "";
+      download_file url "" user;
       "started FileTP download", true)
     else
       "invalid URL", false
@@ -310,8 +310,8 @@
     "http", "Network/FileTP", Arg_multiple (fun args o ->
         try
         (match args with
-          url :: [referer] -> download_file url referer
-        | [url] -> download_file url ""
+          url :: [referer] -> download_file url referer o.conn_user.ui_user_name
+        | [url] -> download_file url "" o.conn_user.ui_user_name
         | _ -> raise Not_found);
         let buf = o.conn_buf in
         if o.conn_output = HTML then
@@ -405,7 +405,7 @@
   CommonNetwork.register_commands commands;
   network.op_network_share <- (fun fullname codedname size -> ());
   network.op_network_search <- (fun ss buf -> ());
-  network.op_network_download <- (fun r -> dummy_file);
+  network.op_network_download <- (fun r user -> dummy_file);
   file_ops.op_file_commit <- (fun file new_name -> clean_stop file);
   file_ops.op_file_pause <- (fun file -> 
     List.iter (fun c ->
diff -a -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -N -r -u ./src/networks/gnutella/gnutellaComplexOptions.ml ./src/networks/gnutella/gnutellaComplexOptions.ml
--- ./src/networks/gnutella/gnutellaComplexOptions.ml	2006-05-25 21:47:25.000000000 +0200
+++ ./src/networks/gnutella/gnutellaComplexOptions.ml	2006-09-19 19:03:10.000000000 +0200
@@ -130,7 +130,7 @@
       file_uids := hash :: !file_uids;
     with _ -> ());
   
-  let file = new_file file_temp file_name file_size !file_uids in
+  let file = new_file file_temp file_name file_size !file_uids CommonUserDb.admin_user in
   
   (try
       file.file_ttr <- Some (get_value "file_ttr" (value_to_array 
diff -a -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -N -r -u ./src/networks/gnutella/gnutellaGlobals.ml ./src/networks/gnutella/gnutellaGlobals.ml
--- ./src/networks/gnutella/gnutellaGlobals.ml	2006-09-01 18:22:15.000000000 +0200
+++ ./src/networks/gnutella/gnutellaGlobals.ml	2006-09-19 19:03:10.000000000 +0200
@@ -310,7 +310,7 @@
 let megabyte = Int64.of_int (1024 * 1024)
 let megabytes10 = Int64.of_int (10 * 1024 * 1024)
       
-let new_file file_temporary file_name file_size file_uids = 
+let new_file file_temporary file_name file_size file_uids user =
   let file_temp = Filename.concat !!temp_directory file_temporary in
   let t = Unix32.create_rw file_temp in
   let rec file = {
@@ -329,6 +329,8 @@
       impl_file_fd = Some t;
       impl_file_size = file_size;
       impl_file_downloaded = Int64.zero;
+      impl_file_owner = user;
+      impl_file_group = CommonUserDb.user2_user_default_group user;
       impl_file_val = file;
       impl_file_ops = file_ops;
       impl_file_age = last_time ();          
@@ -357,7 +359,7 @@
 
 exception FileFound of file
   
-let new_file file_id file_name file_size file_uids =
+let new_file file_id file_name file_size file_uids user =
 (*  if file_uids = [] then 
     try Hashtbl.find files_by_key (file_name, file_size) with
       _ -> 
@@ -370,7 +372,7 @@
         try  raise (FileFound (Hashtbl.find files_by_uid uid))
         with Not_found -> ()
     ) file_uids;
-    let file = new_file file_id file_name file_size file_uids in
+    let file = new_file file_id file_name file_size file_uids user in
     List.iter (fun uid -> 
         if !verbose then
           lprintf "Adding file %s\n" (Uid.to_string uid);
diff -a -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -N -r -u ./src/networks/gnutella/gnutellaInteractive.ml ./src/networks/gnutella/gnutellaInteractive.ml
--- ./src/networks/gnutella/gnutellaInteractive.ml	2006-09-05 17:32:17.000000000 +0200
+++ ./src/networks/gnutella/gnutellaInteractive.ml	2006-09-19 19:03:10.000000000 +0200
@@ -77,8 +77,8 @@
       if file_state file = FileDownloading then
         GnutellaServers.really_recover_file file        
 
-let download_file r =
-  let file = GnutellaServers.really_download_file r in
+let download_file r user =
+  let file = GnutellaServers.really_download_file r user in
   recover_file file;
   as_file file
 
@@ -241,8 +241,8 @@
         end
   );
 (* TODO RESULT *)
-  network.op_network_download <- (fun r ->
-      result_download r
+  network.op_network_download <- (fun r user ->
+      result_download r user
   )
   
 let file_num file =
@@ -370,7 +370,7 @@
       List2.tail_map (fun s -> as_server s.server_server)
       !connected_servers
   );
-  network.op_network_parse_url <- (fun url ->
+  network.op_network_parse_url <- (fun url user ->
       match String2.split (String.escaped url) '|' with
       | "gnut://" :: "server" :: ip :: port :: _ ->  
           let ip = Ip.addr_of_string ip in
@@ -402,7 +402,7 @@
               (* Start a download for this file *)
               let rs = new_result name size [] uids [] in
               let r = IndexedResults.get_result rs in
-              let file = download_file r in
+              let file = download_file r user in
               CommonInteractive.start_download file;
               "started Gnutella download", true
             end
diff -a -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -N -r -u ./src/networks/gnutella/gnutellaServers.ml ./src/networks/gnutella/gnutellaServers.ml
--- ./src/networks/gnutella/gnutellaServers.ml	2006-05-20 01:43:55.000000000 +0200
+++ ./src/networks/gnutella/gnutellaServers.ml	2006-09-19 19:03:10.000000000 +0200
@@ -678,14 +678,14 @@
 (*                                                                       *)
 (*************************************************************************)
     
-let really_download_file (r : result_info) =
+let really_download_file (r : result_info) user =
   if !verbose then
     lprintf "download_file\n";
   let file_temp = match r.result_uids with
       [] -> assert false
     | uid :: _ -> Uid.to_file_string uid in
   let file = new_file file_temp
-    (List.hd r.result_names) r.result_size r.result_uids in
+    (List.hd r.result_names) r.result_size r.result_uids user in
   if !verbose then
     lprintf "DOWNLOAD FILE %s\n" file.file_name; 
   if not (List.memq file !current_files) then begin
